Index: codes/icosagcm/devel/Python/test/xml/context_icosa.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/context_icosa.xml	(revision 754)
+++ 	(revision )
@@ -1,134 +1,0 @@
-<context id="icosagcm" >
-
-<!----------------- objects that must be initialized by DYNAMICO ---------------------->
-
-  <axis_definition>
-    <axis id="lev" name="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
-    <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
-    <axis id="nq" name="nq" n_glo="5" value="(0,4)[1 2 3 4 5]"/>
-  </axis_definition>    
-  
-  <domain_definition>
-
-    <domain_group id="i"> 
-      <domain id="i" name="mesh"/>     
-    </domain_group> 
-
-  </domain_definition>    
-
-<!------------------------------ objects defined in XML -------------------------------->
-
-  <calendar type="d360" start_date="2000-01-01 00:00:00" time_origin="2000-01-01 00:00:00"/>
-  <field_definition src="./field_def.xml" />
-
-  <domain_definition>
-     <domain id="regular_half_degree" type="rectilinear" ni_glo="720" nj_glo="360" >
-       <generate_rectilinear_domain />
-       <interpolate_domain order="1"/>
-     </domain> 
-     
-     <domain id="regular_one_degree" type="rectilinear" ni_glo="360" nj_glo="180" >
-       <generate_rectilinear_domain />
-       <interpolate_domain order="1"/>
-     </domain> 
-     
-     <domain id="regular_two_degree" type="rectilinear" ni_glo="180" nj_glo="90" >
-       <generate_rectilinear_domain />
-       <interpolate_domain order="1"/>
-     </domain> 
-  </domain_definition>    
-     
-  <file_definition src="./filedef_dcmip2016.xml" /> 
-
-<!--  <calendar type="d360" start_date="2000-01-01 00:00:00" time_origin="2000-01-01 00:00:00"/> 
-  
-  <field_definition src="./field_def.xml" />
-
-
-  <file_definition type="one_file" par_access="collective">
-
-    <file id="output" name="output" enabled=".FALSE."  output_freq="2h" sync_freq="2h" output_level="10" >
-      <field_group group_ref="standard_output"/>
-    </file>
-
-    <file id="restart" name="restart" enabled="true">
-       <field_group id="group_restart" operation="once"> 
-          <field id="it_restart" name="iteration"  grid_ref="scalar" />
-          <field id="q_restart" name="q"  grid_ref="grid_q" />
-          <field_group domain_ref="i"> 
-             <field id="ps_restart" name="ps" />
-             <field id="phis_restart" name="phis" />
-             <field_group axis_ref="lev" >
-                <field id="theta_rhodz_restart" name="theta_rhodz" />
-                <field id="u_restart" name="u" domain_ref="u"/>
-                <field id="ulon_restart" name="ulon" />
-                <field id="ulat_restart" name="ulat" />
-             </field_group>
-          </field_group>
-       </field_group>
-    </file>
-
-    <file id="start" name="start" enabled="true">
-       <field_group id="group_start" operation="once"> 
-          <field id="it_start" name="iteration"  grid_ref="scalar" enabled="false"/>
-          <field id="q_start" name="q"  grid_ref="grid_q_read" />
-          <field_group domain_ref="i"> 
-             <field id="ps_start" name="ps" />
-             <field id="phis_start" name="phis" />
-             <field_group axis_ref="lev_read" >
-                <field id="theta_rhodz_start" name="theta_rhodz" />
-                <field id="u_start" name="u" domain_ref="u"/>
-                <field id="ulon_start" name="ulon" />
-                <field id="ulat_start" name="ulat" />
-             </field_group>
-          </field_group>
-       </field_group>
-    </file>
-
-    
-  </file_definition>
-    
-  <axis_definition>
-    <axis id="lev" name="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
-    <axis id="lev_read" />
-    <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
-    <axis id="lev_pressure" positive="down"  n_glo="2" unit="Pa" value="(0,1)[85000 50000]" >
-      <interpolate_axis order="1" coordinate="p" />
-    </axis>    
-    <axis id="nq" name="nq" n_glo="5" value="(0,4)[1 2 3 4 5]"/>
-  </axis_definition>    
-  
-  <domain_definition>
-    
-     <domain_group id="i"> 
-       <domain id="i" name="mesh"/>     
-     </domain_group> 
-     
-     
-     <domain id="v" />
-     <domain id="u" />
-     
-  </domain_definition>    
-  
-  <grid_definition>    
-    <grid id="scalar">
-      <scalar />
-    </grid>
-    
-    <grid id="grid_q">
-      <domain domain_ref="i" />
-      <axis axis_ref="lev" />
-      <axis axis_ref="nq" />
-    </grid >
-
-    <grid id="grid_q_read">
-      <domain domain_ref="i" />
-      <axis axis_ref="lev_read" />
-      <axis axis_ref="nq" />
-    </grid >
- 
-  </grid_definition>   
-
--->
-  
-</context>
Index: codes/icosagcm/devel/Python/test/xml/context_icosa_full.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/context_icosa_full.xml	(revision 755)
+++ codes/icosagcm/devel/Python/test/xml/context_icosa_full.xml	(revision 755)
@@ -0,0 +1,134 @@
+<context id="icosagcm" >
+
+<!----------------- objects that must be initialized by DYNAMICO ---------------------->
+
+  <axis_definition>
+    <axis id="lev" name="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
+    <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
+    <axis id="nq" name="nq" n_glo="5" value="(0,4)[1 2 3 4 5]"/>
+  </axis_definition>    
+  
+  <domain_definition>
+
+    <domain_group id="i"> 
+      <domain id="i" name="mesh"/>     
+    </domain_group> 
+
+  </domain_definition>    
+
+<!------------------------------ objects defined in XML -------------------------------->
+
+  <calendar type="d360" start_date="2000-01-01 00:00:00" time_origin="2000-01-01 00:00:00"/>
+  <field_definition src="./field_def.xml" />
+
+  <domain_definition>
+     <domain id="regular_half_degree" type="rectilinear" ni_glo="720" nj_glo="360" >
+       <generate_rectilinear_domain />
+       <interpolate_domain order="1"/>
+     </domain> 
+     
+     <domain id="regular_one_degree" type="rectilinear" ni_glo="360" nj_glo="180" >
+       <generate_rectilinear_domain />
+       <interpolate_domain order="1"/>
+     </domain> 
+     
+     <domain id="regular_two_degree" type="rectilinear" ni_glo="180" nj_glo="90" >
+       <generate_rectilinear_domain />
+       <interpolate_domain order="1"/>
+     </domain> 
+  </domain_definition>    
+     
+  <file_definition src="./filedef_dcmip2016.xml" /> 
+
+<!--  <calendar type="d360" start_date="2000-01-01 00:00:00" time_origin="2000-01-01 00:00:00"/> 
+  
+  <field_definition src="./field_def.xml" />
+
+
+  <file_definition type="one_file" par_access="collective">
+
+    <file id="output" name="output" enabled=".FALSE."  output_freq="2h" sync_freq="2h" output_level="10" >
+      <field_group group_ref="standard_output"/>
+    </file>
+
+    <file id="restart" name="restart" enabled="true">
+       <field_group id="group_restart" operation="once"> 
+          <field id="it_restart" name="iteration"  grid_ref="scalar" />
+          <field id="q_restart" name="q"  grid_ref="grid_q" />
+          <field_group domain_ref="i"> 
+             <field id="ps_restart" name="ps" />
+             <field id="phis_restart" name="phis" />
+             <field_group axis_ref="lev" >
+                <field id="theta_rhodz_restart" name="theta_rhodz" />
+                <field id="u_restart" name="u" domain_ref="u"/>
+                <field id="ulon_restart" name="ulon" />
+                <field id="ulat_restart" name="ulat" />
+             </field_group>
+          </field_group>
+       </field_group>
+    </file>
+
+    <file id="start" name="start" enabled="true">
+       <field_group id="group_start" operation="once"> 
+          <field id="it_start" name="iteration"  grid_ref="scalar" enabled="false"/>
+          <field id="q_start" name="q"  grid_ref="grid_q_read" />
+          <field_group domain_ref="i"> 
+             <field id="ps_start" name="ps" />
+             <field id="phis_start" name="phis" />
+             <field_group axis_ref="lev_read" >
+                <field id="theta_rhodz_start" name="theta_rhodz" />
+                <field id="u_start" name="u" domain_ref="u"/>
+                <field id="ulon_start" name="ulon" />
+                <field id="ulat_start" name="ulat" />
+             </field_group>
+          </field_group>
+       </field_group>
+    </file>
+
+    
+  </file_definition>
+    
+  <axis_definition>
+    <axis id="lev" name="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
+    <axis id="lev_read" />
+    <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
+    <axis id="lev_pressure" positive="down"  n_glo="2" unit="Pa" value="(0,1)[85000 50000]" >
+      <interpolate_axis order="1" coordinate="p" />
+    </axis>    
+    <axis id="nq" name="nq" n_glo="5" value="(0,4)[1 2 3 4 5]"/>
+  </axis_definition>    
+  
+  <domain_definition>
+    
+     <domain_group id="i"> 
+       <domain id="i" name="mesh"/>     
+     </domain_group> 
+     
+     
+     <domain id="v" />
+     <domain id="u" />
+     
+  </domain_definition>    
+  
+  <grid_definition>    
+    <grid id="scalar">
+      <scalar />
+    </grid>
+    
+    <grid id="grid_q">
+      <domain domain_ref="i" />
+      <axis axis_ref="lev" />
+      <axis axis_ref="nq" />
+    </grid >
+
+    <grid id="grid_q_read">
+      <domain domain_ref="i" />
+      <axis axis_ref="lev_read" />
+      <axis axis_ref="nq" />
+    </grid >
+ 
+  </grid_definition>   
+
+-->
+  
+</context>
Index: codes/icosagcm/devel/Python/test/xml/filedef_dcmip2016.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/filedef_dcmip2016.xml	(revision 754)
+++ 	(revision )
@@ -1,70 +1,0 @@
-<file_definition > 
-
-  <file id="output_dcmip2016_native" convention="UGRID" enabled="false" output_freq="24h" sync_freq="24h" output_level="10" timeseries="none" description="DCMIP41" > 
-    
-    <field_group id="dcmip2016_output_field_once" operation="once" freq_offset="0ts" ts_enabled="true">
-      <field field_ref="timestep" name="mdt" />
-      <field field_ref="preff" name="P0" long_name="reference pressure" />
-      <field field_ref="ap" name="hyai"   />
-      <field field_ref="bp" name="hybi"   />
-      <field field_ref="mid_ap" name="hyam"   />
-      <field field_ref="mid_bp" name="hybm"   />
-    </field_group>
-    
-    
-    <field_group id="dcmip2016_output_field" ts_enabled="true">
-      <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
-      <field field_ref="phis" operation="once" freq_offset="0ts" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
-      <field field_ref="geopot"  name="PHI"   standard_name="geopotential" long_name="geopotential" unit="m2/s2"/>
-      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
-      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
-      <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
-      <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
-      <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
-      <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
-      <field field_ref="precl"  name="PRECT"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
-      <field field_ref="Q1_col_int"  name="Q1_col_int"      long_name="Single chlorine column integrated mixing ratio"  unit="kg/m2"/> 
-      <field field_ref="Q2_col_int"  name="Q2_col_int"      long_name="Chlorine gas column integrated mixing ratio"  unit="kg/m2"/> 
-      <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
-      <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
-      <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
-      <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
-      <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
-      <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
-      <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
-      <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
-      <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
-      
-    </field_group>
-
-    <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > DCMIP41 </variable>
-    <variable name="horizontal_resolution" type="string" > native (grid points : 80x80x10) </variable>
-    <variable name="levels" type="string" > L10 </variable>
-    <variable name="grid" type="string" > hex </variable>
-    <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 24h </variable>    
-
-  </file>
-
-
-  <file id="output_dcmip2016_regular" enabled="true" output_freq="24h" sync_freq="24h" output_level="10" description="DCMIP41" timeseries="none" > 
-    
-    <field_group group_ref="dcmip2016_output_field_once"/>
-    
-    <field_group group_ref="dcmip2016_output_field" domain_ref="regular_two_degree" />
-
-    <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > DCMIP41 </variable>
-    <variable name="horizontal_resolution" type="string" > two_degree interpolated (grid points : 80 x 80 x 10) </variable>
-    <variable name="levels" type="string" > L30 </variable>
-    <variable name="grid" type="string" > hex </variable>
-    <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 24h </variable>    
-
-  </file>
-
-
-</file_definition>
Index: codes/icosagcm/devel/Python/test/xml/filedef_full.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/filedef_full.xml	(revision 755)
+++ codes/icosagcm/devel/Python/test/xml/filedef_full.xml	(revision 755)
@@ -0,0 +1,70 @@
+<file_definition > 
+
+  <file id="output_dcmip2016_native" convention="UGRID" enabled="false" output_freq="24h" sync_freq="24h" output_level="10" timeseries="none" description="DCMIP41" > 
+    
+    <field_group id="dcmip2016_output_field_once" operation="once" freq_offset="0ts" ts_enabled="true">
+      <field field_ref="timestep" name="mdt" />
+      <field field_ref="preff" name="P0" long_name="reference pressure" />
+      <field field_ref="ap" name="hyai"   />
+      <field field_ref="bp" name="hybi"   />
+      <field field_ref="mid_ap" name="hyam"   />
+      <field field_ref="mid_bp" name="hybm"   />
+    </field_group>
+    
+    
+    <field_group id="dcmip2016_output_field" ts_enabled="true">
+      <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
+      <field field_ref="phis" operation="once" freq_offset="0ts" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
+      <field field_ref="geopot"  name="PHI"   standard_name="geopotential" long_name="geopotential" unit="m2/s2"/>
+      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
+      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
+      <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
+      <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
+      <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
+      <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
+      <field field_ref="precl"  name="PRECT"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
+      <field field_ref="Q1_col_int"  name="Q1_col_int"      long_name="Single chlorine column integrated mixing ratio"  unit="kg/m2"/> 
+      <field field_ref="Q2_col_int"  name="Q2_col_int"      long_name="Chlorine gas column integrated mixing ratio"  unit="kg/m2"/> 
+      <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
+      <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
+      <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
+      <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
+      <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
+      <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+      <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
+      <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
+      <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
+      <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
+      
+    </field_group>
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="test_case" type="string" > DCMIP41 </variable>
+    <variable name="horizontal_resolution" type="string" > native (grid points : 80x80x10) </variable>
+    <variable name="levels" type="string" > L10 </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+    <variable name="time_frequency" type="string" > 24h </variable>    
+
+  </file>
+
+
+  <file id="output_dcmip2016_regular" enabled="true" output_freq="24h" sync_freq="24h" output_level="10" description="DCMIP41" timeseries="none" > 
+    
+    <field_group group_ref="dcmip2016_output_field_once"/>
+    
+    <field_group group_ref="dcmip2016_output_field" domain_ref="regular_two_degree" />
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="test_case" type="string" > DCMIP41 </variable>
+    <variable name="horizontal_resolution" type="string" > two_degree interpolated (grid points : 80 x 80 x 10) </variable>
+    <variable name="levels" type="string" > L30 </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+    <variable name="time_frequency" type="string" > 24h </variable>    
+
+  </file>
+
+
+</file_definition>
Index: codes/icosagcm/devel/Python/test/xml/filedef_simple.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/filedef_simple.xml	(revision 754)
+++ codes/icosagcm/devel/Python/test/xml/filedef_simple.xml	(revision 755)
@@ -30,5 +30,5 @@
 
 
-  <file id="output_dynamico_regular" enabled="true" output_freq="24h" sync_freq="24h" output_level="10" description="DCMIP41" timeseries="none" > 
+<!--  <file id="output_dynamico_regular" enabled="true" output_freq="24h" sync_freq="24h" output_level="10" description="DCMIP41" timeseries="none" > 
     
     <field_group group_ref="dcmip2016_output_field_once"/>
@@ -45,5 +45,5 @@
 
   </file>
-
+-->
 
 </file_definition>
Index: codes/icosagcm/devel/Python/test/xml/iodef.xml
===================================================================
--- codes/icosagcm/devel/Python/test/xml/iodef.xml	(revision 754)
+++ codes/icosagcm/devel/Python/test/xml/iodef.xml	(revision 755)
@@ -3,5 +3,5 @@
 	<context  id="xios">
 		<variable_definition>
-                <variable id="print_file" type="bool"> true </variable> 
+                <variable id="print_file" type="bool"> false </variable> 
        		<variable_group id="buffer">
          	</variable_group>
Index: codes/icosagcm/devel/Python/test/xml/link.sh
===================================================================
--- codes/icosagcm/devel/Python/test/xml/link.sh	(revision 755)
+++ codes/icosagcm/devel/Python/test/xml/link.sh	(revision 755)
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+function cmd_suffix()
+{
+    rm -f *.xml
+    for name in context_icosa field_def filedef ; do
+	ln -s xml/${name}_$1.xml ${name}.xml
+    done
+    ln -s iodef.xml
+}
+
+echo "Usage : xml/link.sh [simple|full]"
+
+cmd_suffix $1
+ls -l *.xml